/*
This is a part of the LiteStep Shell Source code.

Copyright (C) 1997-2001 The LiteStep Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/ 
/*
  Copyright (C) 1998-1999 Johan Redestig
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#if !defined(AFX_COMMANDITEM_H__5CAE4533_748B_11D2_B6A1_00C0DF466974__INCLUDED_)
#define AFX_COMMANDITEM_H__5CAE4533_748B_11D2_B6A1_00C0DF466974__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TitleItem.h"

/**
a menu item that has the ability to execute commands with
shellexecute
*/
class CommandItem : public TitleItem
{
public:

	/**
	constructs a command item object
	@param pszCommand the command associated with this command item (may be bang)
	@param pszArgument optional argument to pszCommand
	@param pszTitle the text to be rendered on the menu item
	*/
	CommandItem(LPCSTR pszCommand, LPCSTR pszArgument, LPCSTR pszTitle);

	/// destroys the commanditem object
	virtual ~CommandItem();

	/// executes this menu item object
	void Invoke();
	void RInvoke();

protected:

	virtual UINT GetDrawTextFormat();

	char* m_pszCommand;
	char* m_pszArgument;
};

#endif // !defined(AFX_COMMANDITEM_H__5CAE4533_748B_11D2_B6A1_00C0DF466974__INCLUDED_)
