//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
// This is a part of the LiteStep Shell source code.
//
// Copyright (C) 1997-2009  LiteStep Development Team
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
// This file contains workarounds for different compilers and PSDK versions
//
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#if !defined(FIXUP_H)
#define FIXUP_H

#include "StdAfx.h"


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
// Fix {Get,Set}{Window,Class}LongPtr warnings
//
// The #defines in the original headers will always produce warnings, even
// if the functions are used correctly. The only way to avoid that is to
// redefine the functions for 32-Bit code.
//
#if defined(_MSC_VER) && !defined(_WIN64)
#undef GetWindowLongPtrA
#undef GetWindowLongPtrW
#undef SetWindowLongPtrA
#undef SetWindowLongPtrW
#undef SetClassLongPtrA
#undef SetClassLongPtrW

inline LONG_PTR WINAPI GetWindowLongPtrA(HWND hWnd, int nIndex)
{
    return GetWindowLongA(hWnd, nIndex);
}

inline LONG_PTR WINAPI GetWindowLongPtrW(HWND hWnd, int nIndex)
{
    return GetWindowLongW(hWnd, nIndex);
}

inline LONG_PTR WINAPI SetWindowLongPtrA(HWND hWnd, int nIndex, LONG_PTR dwNewLong)
{
    return SetWindowLongA(hWnd, nIndex, static_cast<LONG>(dwNewLong));
}

inline LONG_PTR WINAPI SetWindowLongPtrW(HWND hWnd, int nIndex, LONG_PTR dwNewLong)
{
    return SetWindowLongW(hWnd, nIndex, static_cast<LONG>(dwNewLong));
}

inline ULONG_PTR WINAPI SetClassLongPtrA(HWND hWnd, int nIndex, LONG_PTR dwNewLong)
{
    return SetClassLongA(hWnd, nIndex, static_cast<LONG>(dwNewLong));
}

inline ULONG_PTR WINAPI SetClassLongPtrW(HWND hWnd, int nIndex, LONG_PTR dwNewLong)
{
    return SetClassLongW(hWnd, nIndex, static_cast<LONG>(dwNewLong));
}
#endif // defined(_MSC_VER) && !defined(_WIN64)


#endif // FIXUP_H
